# frozen_string_literal: true

module ActiveResource::Associations::Builder
  class BelongsTo < Association
    self.valid_options += [:foreign_key, :embed]

    self.macro = :belongs_to

    def build
      validate_options
      embed = options.delete(:embed)

      reflection = model.create_reflection(self.class.macro, name, options)
      model.defines_belongs_to_finder_method(reflection)
      model.defines_belongs_to_embed(reflection)

      reflection
    end
  end
end
